unit Code;

interface

uses SysUtils, dialogs, Classes;

function DJSEncode(input: string): string;
function DJSDecode(input: string): string;
procedure MakeRegFile(fs, regto: string);
function CheckRegFile(fs: string):string;


implementation

uses DoIt;
var Init: boolean;

function InitRand:char;
begin
  if not Init then begin
    Randomize;
    Result:=chr(trunc(random*256));
    Init:=true;
  end else begin
    Result:=chr(trunc(random*256));
  end;
end;


function Rand(seed:char):char;
var temp: LongInt;
begin
  temp:=Ord(seed);
  temp:=temp*5+1;
  while temp>255 do dec(temp,256);
  Result:=chr(temp);
end;


function DJSEncode(input: string): string;
var a, p: integer;
    r: char;
    out: string;
begin
  r:=InitRand;
  p:=1;
  r:=rand(r);
  out:=IntToHex(ord(r),2);
  r:=rand(r);
  out:=out+IntToHex(length(input) xor ord(r),2);
  for a:=1 to 31 do begin
    r:=rand(r);
    Out:=Out+IntToHex(ord(r) Xor ord(input[p]),2);
    inc(p);
    if p>length(input) then p:=1;
  end;
  Result:=Out;
end;


function HexToChar(input:string):char;
var high, low:byte;
begin
  input:=LowerCase(input);
  high:=pos(input[1],'0123456789abcdef')-1;
  low:=pos(input[2],'0123456789abcdef')-1;
  Result:=chr(high*16+low);
end;


function DJSDecode(input: string): string;
var r: char;
    a, p:integer;
    out: string;
begin
  out:='';
  r:=HexToChar(input[1]+input[2]);
  r:=rand(r);
  p:=ord(HexToChar(input[3]+input[4])) xor ord(r);
{  messagedlg(inttostr(p),mtInformation,[mbOK],0);}
  Delete(input,1,4);
  for a:=0 to p-1 do begin
    r:=rand(r);
    out:=out+chr(ord(r) xor ord(HexToChar(input[2*a+1]+input[2*a+2])));
  end;
  Result:=Out;
end;


procedure MakeRegFile(fs, regto: string);
var rs, e1, e2, er: string;
    a: integer;
    t: TStringList;
begin
  rs:='';
  Randomize;
  for a:=1 to 25 do begin
    rs:=rs+chr(trunc(random*256));
  end;
  e1:=DJSEncode(rs);
  e2:=DJSEncode(rs);
  while e1=e2 do e2:=DJSEncode(rs);
  er:=DJSEncode(regto);
  t:=TStringList.Create;
  t.Add(' ');
  t.Add(' ');
  t.Add(' ');
  t.Strings[0]:=e1;
  t.Strings[1]:=e2;
  t.Strings[2]:=er;
{      MessageDlg(DJSDecode(t.Strings[0]),mtInformation,[mbOK],0);
      MessageDlg(DJSDecode(t.Strings[1]),mtInformation,[mbOK],0);
      MessageDlg(DJSDecode(t.Strings[2]),mtInformation,[mbOK],0);}
  t.SaveToFile(fs);
  t.free;
end;


function CheckRegFile(fs: string):string;
var rs, e1, e2, er: string;
    a: integer;
    t: TStringList;
    Day, Month, Year: word;
    Day2, Month2, Year2: word;
begin
  Result:='';
  DecodeDate(DateStart, Day2,Month2,Year2);
  DecodeDate(now, Day,Month,Year);
{  If (Year<1999) and (Month<10) then begin
     Result:='Trial Registration  (-> Oct/98)';
  end;}
  if (Month2<>Month) and (Day<>1) then Result:='';
  If Result='' then begin
    t:=TStringList.Create;
    try
      t.LoadFromFile(fs);
      e1:=DJSDecode(t.Strings[0]);
      e2:=DJSDecode(t.Strings[1]);
      er:=DJSDecode(t.Strings[2]);
      if e1=e2 then Result:=er;
{      else begin
        MessageDlg(e1,mtInformation,[mbOK],0);
        MessageDlg(e2,mtInformation,[mbOK],0);
        MessageDlg(er,mtInformation,[mbOK],0);
      end;}
      t.Free;
    except
      on EFOpenError do t.free;
    end;
  end;
end;


end.
