unit Options;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, ExtCtrls,
  Profiles, NewProf, Progress, DoIt, Rename, Code, Files, Flash, Longfile, SelDir;

type
  TFrmOptions = class(TForm)
    GroupBox1: TGroupBox;
    LstProfiles: TComboBox;
    ComPNew: TButton;
    ComPName: TButton;
    ComPDel: TButton;
    GroupBox2: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    TxtHost: TEdit;
    TxtUser: TEdit;
    TxtPass: TEdit;
    GroupBox3: TGroupBox;
    Label3: TLabel;
    TxtLocalRoot: TEdit;
    ChkSubDirs: TCheckBox;
    ChkCopyChanges: TRadioButton;
    ChkCopyAll: TRadioButton;
    ChkDelete: TCheckBox;
    ChkDelFromRoot: TCheckBox;
    ChkRename: TCheckBox;
    ComGo: TButton;
    ComClose: TButton;
    Bevel1: TBevel;
    Bevel2: TBevel;
    Bevel3: TBevel;
    Label4: TLabel;
    TmrExit: TTimer;
    TxtTimeDif: TEdit;
    Label5: TLabel;
    Label6: TLabel;
    ChkUpper: TCheckBox;
    TxtRemoteRoot: TEdit;
    ChkLong: TCheckBox;
    Button1: TButton;
    Label9: TLabel;
    Label7: TLabel;
    Label11: TLabel;
    TxtPFor: TEdit;
    Label8: TLabel;
    TxtPFiles: TEdit;
    Label10: TLabel;
    Label12: TLabel;
    ChkLogs: TCheckBox;
    procedure ComCloseClick(Sender: TObject);
    procedure ComSaveClick(Sender: TObject);
    procedure ChkDeleteClick(Sender: TObject);
    procedure SaveProfile(Sender: TObject);
    procedure ComPNewClick(Sender: TObject);
    procedure TmrOpenTimer(Sender: TObject);
    procedure UpdateLstProfiles(Sender: TObject);
    procedure LstProfilesChange(Sender: TObject);
    procedure ComGoClick(Sender: TObject);
    procedure ComPDelClick(Sender: TObject);
    procedure ComPNameClick(Sender: TObject);
    procedure TmrExitTimer(Sender: TObject);
    procedure ChkLongClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FrmOptions: TFrmOptions;
  Profile: TProfile;
  Displaying: boolean;
  NeedSave: boolean;

implementation

{$R *.DFM}

procedure TFrmOptions.ComCloseClick(Sender: TObject);
var mb: Word;
begin
{  if NeedSave then begin
    mb:= MessageDlg('Save settings before exit?', mtConfirmation, [mbYes, mbNo, mbCancel], 0);
    mb:=mrYes;
    if mb=mrYes then SaveProfiles;
    if mb<>mrCancel then Application.Terminate
  end
  else
    Application.Terminate;}
  SaveProfile(Sender);
  SaveProfiles;
  Application.Terminate;
end;

procedure TFrmOptions.ComSaveClick(Sender: TObject);
begin
  SaveProfile(Sender);
  SaveProfiles;
  NeedSave:=false;
end;

procedure TFrmOptions.ChkDeleteClick(Sender: TObject);
begin
  ChkDelFromRoot.Enabled:=ChkDelete.Checked;
  SaveProfile(sender);
end;

procedure TFrmOptions.SaveProfile(Sender: TObject);
var dum: integer;
begin
  if displaying=false then begin
    NeedSave:=true;
    Profile.Name:=LstProfiles.Text;
    Profile.Host:=TxtHost.Text;
    Profile.User:=TxtUser.Text;
    Profile.Pass:=TxtPass.Text;
{    Profile.LocalRoot:=TxtLocalRoot.Text;}
    Profile.RemoteRoot:=TxtRemoteRoot.Text;
    Profile.SubDirs:=ChkSubDirs.Checked;
    if ChkCopyAll.Checked then Profile.AllFiles:=true
    else Profile.AllFiles:=false;
    Profile.Delete:=ChkDelete.Checked;
    Profile.DelFromRoot:=ChkDelFromRoot.Checked;
    Profile.Rename:=ChkRename.Checked;
    Profile.Upper:=ChkUpper.Checked;
    Profile.UseLongFN:=ChkLong.Checked;
    Profile.AllLogs:=ChkLogs.Checked;
    try
      Profile.TimeDif:=StrToInt(TxtTimeDif.Text);
    except
      on EConvertError do Profile.TimeDif:=0;
    end;
    try
      Profile.PauseFor:=StrToInt(TxtPFor.Text);
    except
      on EConvertError do Profile.PauseFor:=0;
    end;
    try
      Profile.PauseAfter:=StrToInt(TxtPFiles.Text);
    except
      on EConvertError do Profile.PauseAfter:=0;
    end;
    SetProfile(Profile);
  end;
end;


procedure TFrmOptions.UpdateLstProfiles(Sender: TObject);
var a:integer;
begin
  LstProfiles.Items.Clear;
  for a:=0 to NumberOfProfiles-1 do
    begin
      Profile:=GetProfileNum(a);
      LstProfiles.Items.Add (Profile.Name);
    end;
end;


procedure TFrmOptions.ComPNewClick(Sender: TObject);
var a:integer;
begin
  FrmNewProfile.ShowModal;
  If FrmNewProfile.ModalResult=mrOK then begin
    NeedSave:=true;
    SaveProfile(Sender);
    Profile.Name:=FrmNewProfile.Password.Text;
    AddProfile(Profile);
    UpdateLstProfiles(Sender);
    for a:=0 to LstProfiles.Items.Count-1 do
      if LstProfiles.Items[a]=FrmNewProfile.Password.Text then
        LstPRofiles.ItemIndex:=a;
  end;
end;


procedure TFrmOptions.TmrOpenTimer(Sender: TObject);
var a, b:integer;
    reg:string;
    param:string;
begin
  DateStart:=now;
  CanGoByeBye:=false;
{  AddRegMessage('c:\index.htm','c:\index.tst');}
{  MakeRegFile('c:\testreg.dat','DJSpillett');}
{  MessageDlg (FloatToStr(int(GetVersion/16777216)),mtInformation,[mbOK],0);}
  if int(GetVersion/16777216)<7 then begin
    ChkLong.Enabled:=false;
    ChkLong.Checked:=false;
  end;
  ChkUpper.Enabled:=not ChkLong.Checked;
  FrmProgress.DirList.Directory:=GetMyPath;
  reg:=CheckRegFile(GetMyPath+'regcode.dat');
  {AddRegMessage('c:\autoexec.ad3','c:\autoexec.tst');}
  {AddRegMessage('c:\index.htm','c:\index.tst');}
  if reg='' then
{    MessageDlg('This copy of WholeSite is unregistered',mtInformation,[mbOK],0)}
    FrmOptions.Caption:=Application.Title+'     Unregistered'
  else
    FrmOptions.Caption:=Application.Title+'     Registered to: '+reg;
  LoadProfiles;
  if NumberOfProfiles=0 then ComPNewClick(Sender);
  if NumberOfProfiles=0 then Close;
  UpdateLstProfiles(Sender);
  LstProfiles.ItemIndex:=0;
  LstProfilesChange(Sender);
  NeedSave:=false;
  Application.ShowHint:=true;
  TmrExit.Enabled:=true;
  RunningAuto:=false;
  if ParamCount>0 then begin
    Param:=ParamStr(1);
    for a:=1 to length(param) do if param[a]='_' then param[a]:=' ';
    for a:=0 to LstProfiles.Items.Count-1 do begin
      if LowerCase(LstProfiles.Items[a])=LowerCase(Param) then begin
        LstProfiles.ItemIndex:=a;
        LstProfilesChange(sender);
        RunningAuto:=true;
        FrmProgress.Show;
      end;
    end;
  end;
End;


procedure TFrmOptions.LstProfilesChange(Sender: TObject);
begin
  Displaying:=true;
  Profile:=GetProfile(LstProfiles.Text);
  TxtHost.Text:=Profile.Host;
  TxtUser.Text:=Profile.User;
  TxtPass.Text:=Profile.Pass;
  If Profile.UseLongFN then
    TxtLocalRoot.Text:=Profile.LongRoot
  else
    TxtLocalRoot.Text:=Profile.LocalRoot;
  TxtRemoteRoot.Text:=Profile.RemoteRoot;
  ChkSubDirs.Checked:=Profile.SubDirs;
  if Profile.AllFiles then ChkCopyAll.Checked:=true
  else ChkCopyChanges.Checked:=true;
  ChkDelete.Checked:=Profile.Delete;
  ChkDelFromRoot.Checked:=Profile.DelFromRoot;
  ChkRename.Checked:=Profile.Rename;
  TxtTimeDif.Text:=IntToStr(Profile.TimeDif);
  ChkUpper.Checked:=Profile.Upper;
  ChkLong.Checked:=Profile.UseLongFN;
  ChkLogs.Checked:=Profile.AllLogs;
  TxtPFor.Text:=IntToStr(Profile.PauseFor);
  TxtPFiles.Text:=IntToStr(Profile.PauseAfter);
  Displaying:=false;
end;


procedure TFrmOptions.ComGoClick(Sender: TObject);
var mb: Word;
    ProfToDo :TProfile;
    ex: boolean;
begin
{  if NeedSave then begin
    mb:= MessageDlg('Save settings before running?', mtConfirmation, [mbYes, mbNo, mbCancel], 0);
    if mb=mrYes then SaveProfiles;
    if mb<>mrCancel then begin
      FrmProgress.Caption:=FrmProgress.Caption+' - Running profile: '+Profile.Name;
      FrmProgress.Show;
      Self.Hide;
      Application.ProcessMessages;
      TmrExit.Interval:=250;
      DoTransfer(GetProfile(LstProfiles.Text));
    end
  end
  else begin}
{    Profile.HasRun:=true;
    Profile.LastRun:=Now; }
    DateStart:=now;
    CanGoByeBye:=false;
    SaveProfile(Sender);
    SaveProfiles;
    ProfToDo:=GetProfile(LstProfiles.Text);
    ex:=false;
    try
{      FrmProgress.DirList.Directory:=TxtLocalRoot.Text;}
      FrmProgress.DirList.Directory:=ProfToDo.LocalRoot;
    except
      on EInOutError do begin
        MessageDlg('Directory specified as containing the local copy can not be accessed',
                   mtInformation,[mbOK],0);
        ex:=true;
      end;
    end;
    if not ex then begin
      FrmProgress.LblLog.Font.Color:=clBtnFace;
      FrmProgress.Show;
      Self.Hide;
      Application.ProcessMessages;
      DoTransfer(ProfToDo);
    end;
 { end;}
end;


procedure TFrmOptions.ComPDelClick(Sender: TObject);
var Last :integer;
begin
  if MessageDlg('Are you sure?', mtConfirmation, [mbYes, mbNo], 0)=mrYes then begin
    last:=LstProfiles.ItemIndex;
    DeleteProfile(LstProfiles.Text);
    UpdateLstProfiles(Sender);
    dec(last);
    if last<0 then last:=0;
    LstProfiles.ItemIndex:=last;
    LstProfilesChange(Sender);
    NeedSave:=true;
  end;
end;


procedure TFrmOptions.ComPNameClick(Sender: TObject);
var a:integer;
begin
  FrmRenameProfile.ShowModal;
  If FrmRenameProfile.ModalResult=mrOK then begin
    NeedSave:=true;
    SaveProfile(Sender);
    Profile.Name:=FrmRenameProfile.Password.Text;
    AddProfile(Profile);
    DeleteProfile(LstProfiles.Text);
    UpdateLstProfiles(Sender);
    for a:=0 to LstProfiles.Items.Count-1 do
      if LstProfiles.Items[a]=FrmRenameProfile.Password.Text then
        LstPRofiles.ItemIndex:=a;
  end;
end;


procedure TFrmOptions.TmrExitTimer(Sender: TObject);
begin
  if FrmOptions.Visible=false then
    if FrmProgress.Visible=false then begin
{    if CanGoByeBye then begin}
{      MessageDlg('Bugger?', mtInformation, [mbOK], 0);}
      FrmOptions.Close;
    end;
  if FrmOptions.Visible=true then
    if FrmProgress.Visible=true then
      ComGoClick(sender);
end;

procedure TFrmOptions.ChkLongClick(Sender: TObject);
begin
  ChkUpper.Enabled:=not ChkLong.Checked;
  SaveProfile(Sender);
end;

procedure TFrmOptions.Button1Click(Sender: TObject);
begin
  try
    FrmSelDir.Dirs.Directory:=Profile.LocalRoot;
  except
    on EInOutError do Application.ProcessMessages;
  end;
  FrmSelDir.LFN.Checked:=ChkLong.Checked;
  FrmSelDir.ShowModal;
  If FrmSelDir.ModalResult=MrOK then begin
{    TxtLocalRoot.Text:=FrmSelDir.Path.Text;}
    Profile.LocalRoot:=FrmSelDir.ShortPath.Text;
    Profile.LongRoot:=FrmSelDir.Path.Text;
    SaveProfile(Sender);
    LstProfilesChange(Sender);
  end;
end;

end.
