unit ToDo;

interface

uses Classes, GProg, dialogs, sysutils, filedata;

type TToDoRecord = record
     Num : array [0..8] of integer;
     TotUp, TotDown: longint;
end;
type TDoThis = record
     Action: integer;
     Param: Pointer;
end;
const TDRemReadDir=0;
      TDRemFileDelete=1;
      TDRemDirDelete=2;
      TDRemDirCreate=3;
      TDLocDirCreate=4;
      TDUpload=5;
      TDDownload=6;
      TDLocFileDelete=7;
      TDLocDirDelete=8;
      TDSleep=99;
      TDDone=-1;
var StuffToDo, StuffDoing, StuffDone: TToDoRecord;
const WNRetry=0;
      WNError=1;
      WNNext=2;
      WNClose=3;
      WNCloseAll=4;
      WNNone=-1;


procedure InitToDoLists;
procedure AddToToDoList(ToAdd: Pointer; List: integer);
function NextLocalAction: TDoThis;
function NextRemoteAction: TDoThis;
Procedure RegisterDone(Action: integer);


implementation

type TToDoList = record
     Items: TList;
     LastDone: Integer;
end;

var ToDoList : array [0..8] of TToDoList;
    ReadDirs: boolean;
    gloop: integer;




function NextLocalAction: TDoThis;
begin
     result.Action:=TDSleep;
     result.Param:=nil;
end;



function NextRemoteAction: TDoThis;
begin
     result.Action:=TDSleep;
     result.Param:=nil;
     if ToDoList[TDRemDirCreate].Items.Count-ToDoList[TDRemDirCreate].LastDone>0 then begin
        if (ToDoList[TDRemDirCreate].LastDone=0) or
           (((pos(PTDirInfo(ToDoList[TDRemDirCreate].Items[ToDoList[TDRemDirCreate].LastDone-1]).Name,
                PTDirInfo(ToDoList[TDRemDirCreate].Items[ToDoList[TDRemDirCreate].LastDone]).Name)=0))
           or (StuffDoing.Num[TDRemDirCreate]=0))
        then begin
           result.Action:=TDRemDirCreate;
           result.Param:=ToDoList[TDRemDirCreate].Items[ToDoList[TDRemDirCreate].LastDone];
           StuffToDo.Num[TDRemDirCreate]:=StuffToDo.Num[TDRemDirCreate]-1;
           StuffDoing.Num[TDRemDirCreate]:=StuffDoing.Num[TDRemDirCreate]+1;
           ToDoList[TDRemDirCreate].LastDone:=ToDoList[TDRemDirCreate].LastDone+1;
        end;
     end else if StuffDoing.Num[TDRemDirCreate]<1 then begin
        if ToDoList[TDUpload].Items.Count-ToDoList[TDUpload].LastDone>0 then begin
           result.Action:=TDUpload;
           result.Param:=ToDoList[TDUpload].Items[ToDoList[TDUpload].LastDone];
           StuffToDo.Num[TDUpload]:=StuffToDo.Num[TDUpload]-1;
           StuffDoing.Num[TDUpload]:=StuffDoing.Num[TDUpload]+1;
           ToDoList[TDUpload].LastDone:=ToDoList[TDUpload].LastDone+1;
        end;
     end;
end;
Procedure RegisterDone(Action: integer);
begin
    StuffDoing.Num[Action]:=StuffDoing.Num[Action]-1;
    StuffDone.Num[Action]:=StuffDone.Num[Action]+1;
end;



procedure AddToToDoList(ToAdd: Pointer; List: integer);
begin
     ToDoList[List].Items.Add(ToAdd);
     StuffToDo.Num[List]:=StuffToDo.Num[List]+1;
end;



procedure InitToDoLists;
var a: integer;
begin
     for a:=0 to 8 do begin
         ToDoList[a].Items.Clear;
         StuffToDo.Num[a]:=0;
         StuffDoing.num[a]:=0;
         StuffDone.num[a]:=0;
     end;
     StuffToDo.TotUp:=0;
     StuffToDo.TotDown:=0;
     StuffDoing.TotUp:=0;
     StuffDoing.TotDown:=0;
     StuffDone.TotUp:=0;
     StuffDone.TotDown:=0;
     ReadDirs:=false;
end;



initialization
for gloop:=0 to 8 do begin
    ToDoList[gloop].Items:=TList.Create;
    ToDoList[gloop].LastDone:=0;
end;

finalization
for gloop:=0 to 8 do ToDoList[gloop].Items.Destroy;

end.
